.TH xfroot 1 "21 September 1989"
.SH NAME
xfroot \- set fractal root window (monochrome)
.SH SYNOPSIS
.in +.5i
.ti -.5i
xfroot  \%[\-p n] \%[\-P n] \%[\-a r] \%[\-b r] \%[\-c r] \%[\-display display]
.in -.5i
.SH DESCRIPTION
.I Xfroot
sets the X root window to display a monochrome fractal.
The fractal algorithm was published in A. K. Dewdney's
.I "Computer Recreations" 
column in the September 1986
.I "Scientific American" 
and attributed to Barry Martin of Aston University, Birmingham, England.
.sp
.SH OPTIONS
.PP
.B "\-p \-P"
.RS 5
Sets maximum points to calculate to \fIn\fP. \fB\-p\fP sets the maximum
for in-range (i.e. on display) points. \fB\-P\fP sets the total points
to calculate. Defaults: \fB\-p\fP: 25% of pixels in server display.
\fB\-P\fP: 3 times the \fB\-p\fP value.
.RE
.sp
.B "\-a  \-b  \-c"
.RS 5
Sets the corresponding fractal algorithm parameter to the real value 
.IR r .
Interesting values seem to be in the range -1000 < r < 1000.
The algorithm seems sensitive to changes in the values out to the precision 
(double) of the arithmetic, about 16 significant digits.
By default, random values are assigned.
.SH SPECIAL CONSIDERATIONS
With the default parameters, 
.I xfroot
calculates hundreds of thousands of points. Each point requires a double
precision square root, multiply and three or four subtracts, plus integer
arithmetic to determine if the point is in range and store the point in
a bit map. Since each point depends on the value for the previous point,
the calculation does not lend itself to vectorizing or parallelization.
.LP
The following table is a rough guide to the amount of processor time
involved. It gives ranges of fractal points per uniprocessor second measured
on a variety of client hosts. The lower values for a processor reflect
the case when all or most points are in in-range and require bit-manipulation
to record the point.
.sp
.B "      Cray X-MP: 157,000 to 194,000 *"
.br
.B "      Cray 2: 129,000 to 183,000 *"
.br
.B "      Convex C200: 41,000 to 47,000 *"
.br
.B "      Vaxserver 3500: 13,200 to 15,200"
.br
.B "      Sequent Symmetry: 9,900 to 10,500 *"
.br 
.B "      Vaxstation 2000: 4,670 to 5,530"
.br 
.B "      Sun 3/60: 1,960 to 2,060"
.br
.B "      Sun 3/50: 1,270 to 1,330"
.br
.B "      (* = per processor)"
.sp
.SH AUTHORS
.LP
Ed Kubaitis, Computing Services Office, University of Illinois.
.LP
The Xlib code to set the root screen was adapted from code in xphoon
by Jef Poskanzer and Craig Leres, and carries the following copyright:
Copyright (C) 1988 by Jef Poskanzer and Craig Leres.
Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted, provided
that the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation.  This software is provided "as is" without express or
implied warranty.
